############################################################
#
# pdf źեեؤΥϥɥ
#
############################################################
package plugin::jupdf::JupdfHandler;
use strict;
#===========================================================
# 󥹥ȥ饯
#===========================================================
sub new {
	my $class = shift;
	my $self = {};
	return bless $self,$class;
}

#===========================================================
# μ¹
#===========================================================
sub do_action {
	my $self = shift;
	my $wiki = shift;
	my $cgi = $wiki->get_CGI;
	
	my $pagename = $cgi->param("page");
	if($pagename eq ""){
		$pagename = $wiki->config("frontpage");
	}
	
  my $file = $cgi->param("tfile");

  if($file eq ""){
    return $wiki->error("ե뤬ꤵƤޤ");
  }
  unless($wiki->page_exists($pagename)){
    return $wiki->error("ڡ¸ߤޤ");
  }
  unless($wiki->can_show($pagename)){
    return $wiki->error("ڡλȸ¤ޤ");
  }

  my $filepath = $wiki->config('attach_dir')."/".&Util::url_encode($pagename).".".&Util::url_encode($file);
  unless(-e $filepath){
    return $wiki->error("ե뤬ߤĤޤ");
  }
		
  my $contenttype = &get_mime_type($wiki,$file);
  if ($contenttype eq 'application/pdf') {
    my $ua = $ENV{"HTTP_USER_AGENT"};
    open(DATA, $filepath) or die $!;
    print "Content-Type: $contenttype\n\n";
    binmode(DATA);
    while(read(DATA,$_,16384)){ print $_; }
    close(DATA);
  } 
  exit;
}

#===========================================================
# MIMEפޤ
#===========================================================
sub get_mime_type {
	my $wiki = shift;
	my $file = shift;
	my $type = lc(substr($file,rindex($file,".")+1));
	
	my $hash  = &Util::load_config_hash($wiki,$wiki->config('mime_file'));
	my $ctype = $hash->{$type};
	
	if($ctype eq "" ){
		$ctype = "application/octet-stream";
	}
	
	return $ctype;
}

1;
